# Class AbstractOwnableSynchronizer

java.lang.Object
java.util.concurrent.locks.AbstractOwnableSynchronizer

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `AbstractQueuedLongSynchronizer, AbstractQueuedSynchronizer`

public abstract class AbstractOwnableSynchronizer extends Object implements Serializable
A synchronizer that may be exclusively owned by a thread. This class provides a basis for creating locks and related synchronizers that may entail a notion of ownership. The `AbstractOwnableSynchronizer` class itself does not manage or use this information. However, subclasses and tools may use appropriately maintained values to help control and monitor access and provide diagnostics.

Since:
  1.6
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractOwnableSynchronizer()`
  Empty constructor for use by subclasses.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected final Thread`
  `getExclusiveOwnerThread()`
  Returns the thread last set by `setExclusiveOwnerThread`, or `null` if never set.
  `protected final void`
  `setExclusiveOwnerThread(Thread thread)`
  Sets the thread that currently owns exclusive access.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### AbstractOwnableSynchronizer

    protected AbstractOwnableSynchronizer()
    Empty constructor for use by subclasses.

- ## Method Details

  - ### setExclusiveOwnerThread

    protected final void setExclusiveOwnerThread(Thread thread)
    Sets the thread that currently owns exclusive access. A `null` argument indicates that no thread owns access. This method does not otherwise impose any synchronization or `volatile` field accesses.
    Parameters:
      `thread` - the owner thread

  - ### getExclusiveOwnerThread

    protected final Thread getExclusiveOwnerThread()
    Returns the thread last set by `setExclusiveOwnerThread`, or `null` if never set. This method does not otherwise impose any synchronization or `volatile` field accesses.
    Returns:
      the owner thread